#pragma once

namespace JUI
{

    class ContextMenu : public Rect {
    public:
        ContextMenu() : Rect() {
            Name("ContextMenu");
            this->BGColor(Colors::White);
            this->Margin(2_px);
            this->Size({200, 200, 0, 0});
            layout = new VerticalListLayout(this);

            MouseExit += [this] (Vector2 _)
            {
                this->Visible(false);
                this->Parent(nullptr);
                // TODO: Collect
            };
        }

        explicit ContextMenu(Widget* parent) : ContextMenu()
        {
            this->Parent(parent);

        }


        void SetFont(const JGL::Font& use_my_font)
        {
            font = use_my_font;
        }
        TextButton* AddItem(const std::string &name)
        {
            auto* line_item = new TextButton(layout);
            line_item->SetFont(font);
            line_item->SetContent(name);
            line_item->SetTextSize(16);
            line_item->SetTextColor(Colors::Black);
            line_item->Size({0, 20, 1, 0});
            return line_item;
        }
    protected:
        VerticalListLayout* layout;
        JGL::Font font;
    private:

    };

    class UtilityBar : public Rect
    {
    public:
        UtilityBar() : Rect()
        {
            // TODO: Make a note that all JGL::Font members on widgets need to be initialized to JGL::Fonts::Jupiteroid inside the constructor.
            font = JGL::Fonts::Jupiteroid;

            this->Size({0, 20, 1, 0});
            this->Position({0,0,0,0});
            this->BGColor(Colors::White);
            this->BorderColor(Colors::Blues::CornflowerBlue);
            this->BorderWidth(2);
            this->Margin(2_px);
            this->BorderMode(BorderMode::Outline);
            layout = new HorizontalListLayout(this);
            //layout->PaddingLeft(2_px);
            layout->PaddingRight(2_px);
            //layout->PaddingRight(2_px);
        }

        explicit UtilityBar(Widget* parent) : UtilityBar() {
            this->Parent(parent);
        }

        TextButton* AddSubmenu(const std::string& name)
        {
            auto btn = AddButton(name);


            return btn;
        }


        TextButton* AddButton(const std::string& name)
        {
            auto str_width = font.MeasureString(name, 14);

            auto* btn = new TextButton(layout);
            btn->SetFont(font);
            btn->SetTextSize(14);
            btn->SetTextColor(Colors::Black);
            btn->Size({static_cast<int>(str_width.x)+16, 0, 0, 1});
            btn->BorderWidth(0.f);
            btn->SetContent(name);
            return btn;
        }
        void SetFont(const JGL::Font& use_my_font)
        {
            font = use_my_font;
        }
    protected:
        HorizontalListLayout* layout;
        JGL::Font font;
    private:
    };
}